/// autogenerated analytical inverse kinematics code from ikfast program part of OpenRAVE
/// \author Rosen Diankov
///
/// Licensed under the Apache License, Version 2.0 (the "License");
/// you may not use this file except in compliance with the License.
/// You may obtain a copy of the License at
///     http://www.apache.org/licenses/LICENSE-2.0
///
/// Unless required by applicable law or agreed to in writing, software
/// distributed under the License is distributed on an "AS IS" BASIS,
/// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
/// See the License for the specific language governing permissions and
/// limitations under the License.
///
/// ikfast version 0x1000004a generated on 2022-01-03 14:40:02.345816
/// Generated using solver translation3d
/// To compile with gcc:
///     gcc -lstdc++ ik.cpp
/// To compile without any main function as a shared object (might need -llapack):
///     gcc -fPIC -lstdc++ -DIKFAST_NO_MAIN -DIKFAST_CLIBRARY -shared -Wl,-soname,libik.so -o libik.so ik.cpp
#define IKFAST_HAS_LIBRARY
#include "ikfast.h" // found inside share/openrave-X.Y/python/ikfast.h
using namespace ikfast;

// check if the included ikfast version matches what this file was compiled with
#define IKFAST_COMPILE_ASSERT(x) extern int __dummy[(int)x]
IKFAST_COMPILE_ASSERT(IKFAST_VERSION == 0x1000004a);

#include <cmath>
#include <vector>
#include <limits>
#include <algorithm>
#include <complex>

#ifndef IKFAST_ASSERT
#include <stdexcept>
#include <sstream>
#include <iostream>

#ifdef _MSC_VER
#ifndef __PRETTY_FUNCTION__
#define __PRETTY_FUNCTION__ __FUNCDNAME__
#endif
#endif

#ifndef __PRETTY_FUNCTION__
#define __PRETTY_FUNCTION__ __func__
#endif

#define IKFAST_ASSERT(b)                                                                                                                     \
    {                                                                                                                                        \
        if (!(b))                                                                                                                            \
        {                                                                                                                                    \
            std::stringstream ss;                                                                                                            \
            ss << "ikfast exception: " << __FILE__ << ":" << __LINE__ << ": " << __PRETTY_FUNCTION__ << ": Assertion '" << #b << "' failed"; \
            throw std::runtime_error(ss.str());                                                                                              \
        }                                                                                                                                    \
    }

#endif

#if defined(_MSC_VER)
#define IKFAST_ALIGNED16(x) __declspec(align(16)) x
#else
#define IKFAST_ALIGNED16(x) x __attribute((aligned(16)))
#endif

#define IK2PI ((IkReal)6.28318530717959)
#define IKPI ((IkReal)3.14159265358979)
#define IKPI_2 ((IkReal)1.57079632679490)

#ifdef _MSC_VER
#ifndef isnan
#define isnan _isnan
#endif
#ifndef isinf
#define isinf _isinf
#endif
//#ifndef isfinite
//#define isfinite _isfinite
//#endif
#endif // _MSC_VER

// lapack routines
extern "C"
{
    void dgetrf_(const int *m, const int *n, double *a, const int *lda, int *ipiv, int *info);
    void zgetrf_(const int *m, const int *n, std::complex<double> *a, const int *lda, int *ipiv, int *info);
    void dgetri_(const int *n, const double *a, const int *lda, int *ipiv, double *work, const int *lwork, int *info);
    void dgesv_(const int *n, const int *nrhs, double *a, const int *lda, int *ipiv, double *b, const int *ldb, int *info);
    void dgetrs_(const char *trans, const int *n, const int *nrhs, double *a, const int *lda, int *ipiv, double *b, const int *ldb, int *info);
    void dgeev_(const char *jobvl, const char *jobvr, const int *n, double *a, const int *lda, double *wr, double *wi, double *vl, const int *ldvl, double *vr, const int *ldvr, double *work, const int *lwork, int *info);
}

using namespace std; // necessary to get std math routines

#ifdef IKFAST_NAMESPACE
namespace IKFAST_NAMESPACE
{
#endif

    inline float IKabs(float f)
    {
        return fabsf(f);
    }
    inline double IKabs(double f) { return fabs(f); }

    inline float IKsqr(float f) { return f * f; }
    inline double IKsqr(double f) { return f * f; }

    inline float IKlog(float f) { return logf(f); }
    inline double IKlog(double f) { return log(f); }

// allows asin and acos to exceed 1. has to be smaller than thresholds used for branch conds and evaluation
#ifndef IKFAST_SINCOS_THRESH
#define IKFAST_SINCOS_THRESH ((IkReal)1e-7)
#endif

// used to check input to atan2 for degenerate cases. has to be smaller than thresholds used for branch conds and evaluation
#ifndef IKFAST_ATAN2_MAGTHRESH
#define IKFAST_ATAN2_MAGTHRESH ((IkReal)1e-7)
#endif

// minimum distance of separate solutions
#ifndef IKFAST_SOLUTION_THRESH
#define IKFAST_SOLUTION_THRESH ((IkReal)1e-6)
#endif

// there are checkpoints in ikfast that are evaluated to make sure they are 0. This threshold speicfies by how much they can deviate
#ifndef IKFAST_EVALCOND_THRESH
#define IKFAST_EVALCOND_THRESH ((IkReal)0.00001)
#endif

    inline float IKasin(float f)
    {
        IKFAST_ASSERT(f > -1 - IKFAST_SINCOS_THRESH && f < 1 + IKFAST_SINCOS_THRESH); // any more error implies something is wrong with the solver
        if (f <= -1)
            return float(-IKPI_2);
        else if (f >= 1)
            return float(IKPI_2);
        return asinf(f);
    }
    inline double IKasin(double f)
    {
        IKFAST_ASSERT(f > -1 - IKFAST_SINCOS_THRESH && f < 1 + IKFAST_SINCOS_THRESH); // any more error implies something is wrong with the solver
        if (f <= -1)
            return -IKPI_2;
        else if (f >= 1)
            return IKPI_2;
        return asin(f);
    }

    // return positive value in [0,y)
    inline float IKfmod(float x, float y)
    {
        while (x < 0)
        {
            x += y;
        }
        return fmodf(x, y);
    }

    // return positive value in [0,y)
    inline double IKfmod(double x, double y)
    {
        while (x < 0)
        {
            x += y;
        }
        return fmod(x, y);
    }

    inline float IKacos(float f)
    {
        IKFAST_ASSERT(f > -1 - IKFAST_SINCOS_THRESH && f < 1 + IKFAST_SINCOS_THRESH); // any more error implies something is wrong with the solver
        if (f <= -1)
            return float(IKPI);
        else if (f >= 1)
            return float(0);
        return acosf(f);
    }
    inline double IKacos(double f)
    {
        IKFAST_ASSERT(f > -1 - IKFAST_SINCOS_THRESH && f < 1 + IKFAST_SINCOS_THRESH); // any more error implies something is wrong with the solver
        if (f <= -1)
            return IKPI;
        else if (f >= 1)
            return 0;
        return acos(f);
    }
    inline float IKsin(float f) { return sinf(f); }
    inline double IKsin(double f) { return sin(f); }
    inline float IKcos(float f) { return cosf(f); }
    inline double IKcos(double f) { return cos(f); }
    inline float IKtan(float f) { return tanf(f); }
    inline double IKtan(double f) { return tan(f); }
    inline float IKsqrt(float f)
    {
        if (f <= 0.0f)
            return 0.0f;
        return sqrtf(f);
    }
    inline double IKsqrt(double f)
    {
        if (f <= 0.0)
            return 0.0;
        return sqrt(f);
    }
    inline float IKatan2Simple(float fy, float fx)
    {
        return atan2f(fy, fx);
    }
    inline float IKatan2(float fy, float fx)
    {
        if (isnan(fy))
        {
            IKFAST_ASSERT(!isnan(fx)); // if both are nan, probably wrong value will be returned
            return float(IKPI_2);
        }
        else if (isnan(fx))
        {
            return 0;
        }
        return atan2f(fy, fx);
    }
    inline double IKatan2Simple(double fy, double fx)
    {
        return atan2(fy, fx);
    }
    inline double IKatan2(double fy, double fx)
    {
        if (isnan(fy))
        {
            IKFAST_ASSERT(!isnan(fx)); // if both are nan, probably wrong value will be returned
            return IKPI_2;
        }
        else if (isnan(fx))
        {
            return 0;
        }
        return atan2(fy, fx);
    }

    template <typename T>
    struct CheckValue
    {
        T value;
        bool valid;
    };

    template <typename T>
    inline CheckValue<T> IKatan2WithCheck(T fy, T fx, T epsilon)
    {
        CheckValue<T> ret;
        ret.valid = false;
        ret.value = 0;
        if (!isnan(fy) && !isnan(fx))
        {
            if (IKabs(fy) >= IKFAST_ATAN2_MAGTHRESH || IKabs(fx) > IKFAST_ATAN2_MAGTHRESH)
            {
                ret.value = IKatan2Simple(fy, fx);
                ret.valid = true;
            }
        }
        return ret;
    }

    inline float IKsign(float f)
    {
        if (f > 0)
        {
            return float(1);
        }
        else if (f < 0)
        {
            return float(-1);
        }
        return 0;
    }

    inline double IKsign(double f)
    {
        if (f > 0)
        {
            return 1.0;
        }
        else if (f < 0)
        {
            return -1.0;
        }
        return 0;
    }

    template <typename T>
    inline CheckValue<T> IKPowWithIntegerCheck(T f, int n)
    {
        CheckValue<T> ret;
        ret.valid = true;
        if (n == 0)
        {
            ret.value = 1.0;
            return ret;
        }
        else if (n == 1)
        {
            ret.value = f;
            return ret;
        }
        else if (n < 0)
        {
            if (f == 0)
            {
                ret.valid = false;
                ret.value = (T)1.0e30;
                return ret;
            }
            if (n == -1)
            {
                ret.value = T(1.0) / f;
                return ret;
            }
        }

        int num = n > 0 ? n : -n;
        if (num == 2)
        {
            ret.value = f * f;
        }
        else if (num == 3)
        {
            ret.value = f * f * f;
        }
        else
        {
            ret.value = 1.0;
            while (num > 0)
            {
                if (num & 1)
                {
                    ret.value *= f;
                }
                num >>= 1;
                f *= f;
            }
        }

        if (n < 0)
        {
            ret.value = T(1.0) / ret.value;
        }
        return ret;
    }

    /// solves the forward kinematics equations.
    /// \param pfree is an array specifying the free joints of the chain.
    IKFAST_API void ComputeFk(const IkReal *j, IkReal *eetrans, IkReal *eerot)
    {
        IkReal x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10;
        x0 = IKsin(j[1]);
        x1 = IKcos(j[1]);
        x2 = IKsin(j[2]);
        x3 = IKcos(j[2]);
        x4 = IKcos(j[0]);
        x5 = IKsin(j[0]);
        x6 = ((1.14) * x2);
        x7 = ((0.05) * x2);
        x8 = (x0 * x3);
        x9 = (x1 * x3);
        x10 = ((((-1.14) * x8)) + (((0.05) * x9)) + ((x0 * (((1.06) + (((-1.0) * x7)))))) + ((x1 * (((-1.4) + (((-1.0) * x6)))))));
        eetrans[0] = ((0.193) + ((x10 * (((((0.000799999744000123) * x4)) + (((-0.999999680000154) * x5)))))) + (((0.17004765000512) * x5)) + (((0.0598646063999969) * x4)));
        eetrans[1] = ((-0.452) + ((x10 * (((((0.000799999744000123) * x5)) + (((0.999999680000154) * x4)))))) + (((-0.17004765000512) * x4)) + (((0.0598646063999969) * x5)));
        eetrans[2] = ((0.19) + ((x0 * x6)) + (((-1.14) * x9)) + (((-1.0) * x1 * x7)) + (((-0.05) * x8)) + (((1.06) * x1)) + (((1.4) * x0)));
    }

    IKFAST_API int GetNumFreeParameters() { return 1; }
    IKFAST_API int *GetFreeParameters()
    {
        static int freeparams[] = {0};
        return freeparams;
    }
    IKFAST_API int GetNumJoints() { return 4; }

    IKFAST_API int GetIkRealSize() { return sizeof(IkReal); }

    IKFAST_API int GetIkType() { return 0x33000003; }

    class IKSolver
    {
    public:
        IkReal j2, cj2, sj2, htj2, j2mul, j3, cj3, sj3, htj3, j3mul, j4, cj4, sj4, htj4, j4mul, j1, cj1, sj1, htj1, new_px, px, npx, new_py, py, npy, new_pz, pz, npz, pp;
        unsigned char _ij2[2], _nj2, _ij3[2], _nj3, _ij4[2], _nj4, _ij1[2], _nj1;

        IkReal j100, cj100, sj100;
        unsigned char _ij100[2], _nj100;
        bool ComputeIk(const IkReal *eetrans, const IkReal *eerot, const IkReal *pfree, IkSolutionListBase<IkReal> &solutions)
        {
            j2 = numeric_limits<IkReal>::quiet_NaN();
            _ij2[0] = -1;
            _ij2[1] = -1;
            _nj2 = -1;
            j3 = numeric_limits<IkReal>::quiet_NaN();
            _ij3[0] = -1;
            _ij3[1] = -1;
            _nj3 = -1;
            j4 = numeric_limits<IkReal>::quiet_NaN();
            _ij4[0] = -1;
            _ij4[1] = -1;
            _nj4 = -1;
            _ij1[0] = -1;
            _ij1[1] = -1;
            _nj1 = 0;
            for (int dummyiter = 0; dummyiter < 1; ++dummyiter)
            {
                solutions.Clear();
                j1 = pfree[0];
                cj1 = cos(pfree[0]);
                sj1 = sin(pfree[0]);
                px = eetrans[0];
                py = eetrans[1];
                pz = eetrans[2];

                IkReal x11 = IKcos(j1);
                IkReal x12 = IKsin(j1);
                new_px = ((0.169999703920103) + (((0.451845455409477) * x11)) + (((0.000799999744000123) * px * x11)) + (((0.000799999744000123) * py * x12)) + (((-0.999999680000154) * px * x12)) + (((0.193361538124318) * x12)) + (((0.999999680000154) * py * x11)));
                new_py = ((0.19) + (((-1.0) * pz)));
                IkReal x13 = IKcos(j1);
                IkReal x14 = IKsin(j1);
                new_pz = ((0.060000625319804) + (((-0.999999680000154) * py * x14)) + (((0.000799999744000123) * py * x13)) + (((-0.999999680000154) * px * x13)) + (((-0.000799999744000123) * px * x14)) + (((0.193361538124318) * x13)) + (((-0.451845455409477) * x14)));
                px = new_px;
                py = new_py;
                pz = new_pz;
                pp = ((px * px) + (py * py) + (pz * pz));
                {
                    IkReal verifyeval[1];
                    verifyeval[0] = pz;
                    if (IKabs(verifyeval[0]) < 0.0000010000000000)
                    {
                        {
                            IkReal j2eval[1];
                            j2eval[0] = ((px * px) + (py * py));
                            if (IKabs(j2eval[0]) < 0.0000010000000000)
                            {
                                continue; // no branches [j2, j3, j4]
                            }
                            else
                            {
                                {
                                    IkReal j2array[2], cj2array[2], sj2array[2];
                                    bool j2valid[2] = {false};
                                    _nj2 = 2;
                                    IkReal x15 = ((((-2.8) * py)) + (((2.12) * px)));
                                    IkReal x16 = ((((-2.8) * px)) + (((-2.12) * py)));
                                    CheckValue<IkReal> x19 = IKatan2WithCheck(IkReal(x16), IkReal(x15), IKFAST_ATAN2_MAGTHRESH);
                                    if (!x19.valid)
                                    {
                                        continue;
                                    }
                                    IkReal x17 = ((1.0) * (x19.value));
                                    if ((((x15 * x15) + (x16 * x16))) < -0.00001)
                                        continue;
                                    CheckValue<IkReal> x20 = IKPowWithIntegerCheck(IKabs(IKsqrt(((x15 * x15) + (x16 * x16)))), -1);
                                    if (!x20.valid)
                                    {
                                        continue;
                                    }
                                    if ((((-1.0) * (x20.value) * (((-1.7815) + (((-1.0) * (px * px))) + (((-1.0) * (pz * pz))) + (((-1.0) * (py * py))))))) < -1 - IKFAST_SINCOS_THRESH || (((-1.0) * (x20.value) * (((-1.7815) + (((-1.0) * (px * px))) + (((-1.0) * (pz * pz))) + (((-1.0) * (py * py))))))) > 1 + IKFAST_SINCOS_THRESH)
                                        continue;
                                    IkReal x18 = ((-1.0) * (IKasin(((-1.0) * (x20.value) * (((-1.7815) + (((-1.0) * (px * px))) + (((-1.0) * (pz * pz))) + (((-1.0) * (py * py)))))))));
                                    j2array[0] = ((((-1.0) * x18)) + (((-1.0) * x17)));
                                    sj2array[0] = IKsin(j2array[0]);
                                    cj2array[0] = IKcos(j2array[0]);
                                    j2array[1] = ((3.14159265358979) + (((-1.0) * x17)) + (((1.0) * x18)));
                                    sj2array[1] = IKsin(j2array[1]);
                                    cj2array[1] = IKcos(j2array[1]);
                                    if (j2array[0] > IKPI)
                                    {
                                        j2array[0] -= IK2PI;
                                    }
                                    else if (j2array[0] < -IKPI)
                                    {
                                        j2array[0] += IK2PI;
                                    }
                                    j2valid[0] = true;
                                    if (j2array[1] > IKPI)
                                    {
                                        j2array[1] -= IK2PI;
                                    }
                                    else if (j2array[1] < -IKPI)
                                    {
                                        j2array[1] += IK2PI;
                                    }
                                    j2valid[1] = true;
                                    for (int ij2 = 0; ij2 < 2; ++ij2)
                                    {
                                        if (!j2valid[ij2])
                                        {
                                            continue;
                                        }
                                        _ij2[0] = ij2;
                                        _ij2[1] = -1;
                                        for (int iij2 = ij2 + 1; iij2 < 2; ++iij2)
                                        {
                                            if (j2valid[iij2] && IKabs(cj2array[ij2] - cj2array[iij2]) < IKFAST_SOLUTION_THRESH && IKabs(sj2array[ij2] - sj2array[iij2]) < IKFAST_SOLUTION_THRESH)
                                            {
                                                j2valid[iij2] = false;
                                                _ij2[1] = iij2;
                                                break;
                                            }
                                        }
                                        j2 = j2array[ij2];
                                        cj2 = cj2array[ij2];
                                        sj2 = sj2array[ij2];

                                        {
                                            IkReal j3array[1], cj3array[1], sj3array[1];
                                            bool j3valid[1] = {false};
                                            _nj3 = 1;
                                            IkReal x21 = ((0.0383995084862914) * cj2);
                                            IkReal x22 = (py * sj2);
                                            IkReal x23 = ((0.875508793487443) * px);
                                            if (IKabs(((-1.18500883188695) + ((py * x21)) + (((-1.0) * cj2 * x23)) + (((-0.0383995084862914) * px * sj2)) + (((-0.875508793487443) * x22)))) < IKFAST_ATAN2_MAGTHRESH && IKabs(((0.981798632977498) + (((-1.0) * sj2 * x23)) + (((0.0383995084862914) * x22)) + ((px * x21)) + (((0.875508793487443) * cj2 * py)))) < IKFAST_ATAN2_MAGTHRESH && IKabs(IKsqr(((-1.18500883188695) + ((py * x21)) + (((-1.0) * cj2 * x23)) + (((-0.0383995084862914) * px * sj2)) + (((-0.875508793487443) * x22)))) + IKsqr(((0.981798632977498) + (((-1.0) * sj2 * x23)) + (((0.0383995084862914) * x22)) + ((px * x21)) + (((0.875508793487443) * cj2 * py)))) - 1) <= IKFAST_SINCOS_THRESH)
                                                continue;
                                            j3array[0] = IKatan2(((-1.18500883188695) + ((py * x21)) + (((-1.0) * cj2 * x23)) + (((-0.0383995084862914) * px * sj2)) + (((-0.875508793487443) * x22))), ((0.981798632977498) + (((-1.0) * sj2 * x23)) + (((0.0383995084862914) * x22)) + ((px * x21)) + (((0.875508793487443) * cj2 * py))));
                                            sj3array[0] = IKsin(j3array[0]);
                                            cj3array[0] = IKcos(j3array[0]);
                                            if (j3array[0] > IKPI)
                                            {
                                                j3array[0] -= IK2PI;
                                            }
                                            else if (j3array[0] < -IKPI)
                                            {
                                                j3array[0] += IK2PI;
                                            }
                                            j3valid[0] = true;
                                            for (int ij3 = 0; ij3 < 1; ++ij3)
                                            {
                                                if (!j3valid[ij3])
                                                {
                                                    continue;
                                                }
                                                _ij3[0] = ij3;
                                                _ij3[1] = -1;
                                                for (int iij3 = ij3 + 1; iij3 < 1; ++iij3)
                                                {
                                                    if (j3valid[iij3] && IKabs(cj3array[ij3] - cj3array[iij3]) < IKFAST_SOLUTION_THRESH && IKabs(sj3array[ij3] - sj3array[iij3]) < IKFAST_SOLUTION_THRESH)
                                                    {
                                                        j3valid[iij3] = false;
                                                        _ij3[1] = iij3;
                                                        break;
                                                    }
                                                }
                                                j3 = j3array[ij3];
                                                cj3 = cj3array[ij3];
                                                sj3 = sj3array[ij3];
                                                {
                                                    IkReal evalcond[4];
                                                    IkReal x24 = IKcos(j3);
                                                    IkReal x25 = IKsin(j3);
                                                    IkReal x26 = ((1.0) * cj2);
                                                    IkReal x27 = (px * sj2);
                                                    IkReal x28 = ((1.0) * sj2);
                                                    IkReal x29 = (sj2 * x25);
                                                    IkReal x30 = (py * x24);
                                                    evalcond[0] = ((-1.06) + (((-1.0) * py * x26)) + (((0.05) * x25)) + x27 + (((1.14) * x24)));
                                                    evalcond[1] = ((-1.4) + (((-1.0) * py * x28)) + (((0.05) * x24)) + (((-1.0) * px * x26)) + (((-1.14) * x25)));
                                                    evalcond[2] = ((1.14) + ((cj2 * px * x25)) + (((1.4) * x25)) + ((py * x29)) + (((-1.0) * x26 * x30)) + ((x24 * x27)) + (((-1.06) * x24)));
                                                    evalcond[3] = ((0.05) + (((-1.0) * x28 * x30)) + (((-1.4) * x24)) + (((-1.0) * py * x25 * x26)) + (((-1.0) * px * x24 * x26)) + ((x25 * x27)) + (((-1.06) * x25)));
                                                    if (IKabs(evalcond[0]) > IKFAST_EVALCOND_THRESH || IKabs(evalcond[1]) > IKFAST_EVALCOND_THRESH || IKabs(evalcond[2]) > IKFAST_EVALCOND_THRESH || IKabs(evalcond[3]) > IKFAST_EVALCOND_THRESH)
                                                    {
                                                        continue;
                                                    }
                                                }

                                                {
                                                    IkReal j4array[1], cj4array[1], sj4array[1];
                                                    bool j4valid[1] = {false};
                                                    _nj4 = 1;
                                                    j4array[0] = 0;
                                                    sj4array[0] = IKsin(j4array[0]);
                                                    cj4array[0] = IKcos(j4array[0]);
                                                    if (j4array[0] > IKPI)
                                                    {
                                                        j4array[0] -= IK2PI;
                                                    }
                                                    else if (j4array[0] < -IKPI)
                                                    {
                                                        j4array[0] += IK2PI;
                                                    }
                                                    j4valid[0] = true;
                                                    for (int ij4 = 0; ij4 < 1; ++ij4)
                                                    {
                                                        if (!j4valid[ij4])
                                                        {
                                                            continue;
                                                        }
                                                        _ij4[0] = ij4;
                                                        _ij4[1] = -1;
                                                        for (int iij4 = ij4 + 1; iij4 < 1; ++iij4)
                                                        {
                                                            if (j4valid[iij4] && IKabs(cj4array[ij4] - cj4array[iij4]) < IKFAST_SOLUTION_THRESH && IKabs(sj4array[ij4] - sj4array[iij4]) < IKFAST_SOLUTION_THRESH)
                                                            {
                                                                j4valid[iij4] = false;
                                                                _ij4[1] = iij4;
                                                                break;
                                                            }
                                                        }
                                                        j4 = j4array[ij4];
                                                        cj4 = cj4array[ij4];
                                                        sj4 = sj4array[ij4];

                                                        {
                                                            std::vector<IkSingleDOFSolutionBase<IkReal>> vinfos(4);
                                                            vinfos[0].jointtype = 1;
                                                            vinfos[0].foffset = j1;
                                                            vinfos[0].indices[0] = _ij1[0];
                                                            vinfos[0].indices[1] = _ij1[1];
                                                            vinfos[0].maxsolutions = _nj1;
                                                            vinfos[1].jointtype = 1;
                                                            vinfos[1].foffset = j2;
                                                            vinfos[1].indices[0] = _ij2[0];
                                                            vinfos[1].indices[1] = _ij2[1];
                                                            vinfos[1].maxsolutions = _nj2;
                                                            vinfos[2].jointtype = 1;
                                                            vinfos[2].foffset = j3;
                                                            vinfos[2].indices[0] = _ij3[0];
                                                            vinfos[2].indices[1] = _ij3[1];
                                                            vinfos[2].maxsolutions = _nj3;
                                                            vinfos[3].jointtype = 1;
                                                            vinfos[3].foffset = j4;
                                                            vinfos[3].indices[0] = _ij4[0];
                                                            vinfos[3].indices[1] = _ij4[1];
                                                            vinfos[3].maxsolutions = _nj4;
                                                            std::vector<int> vfree(0);
                                                            solutions.AddSolution(vinfos, vfree);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        continue; // verifyAllEquations
                    }
                }
            }
            return solutions.GetNumSolutions() > 0;
        }
    };

    /// solves the inverse kinematics equations.
    /// \param pfree is an array specifying the free joints of the chain.
    IKFAST_API bool ComputeIk(const IkReal *eetrans, const IkReal *eerot, const IkReal *pfree, IkSolutionListBase<IkReal> &solutions)
    {
        IKSolver solver;
        return solver.ComputeIk(eetrans, eerot, pfree, solutions);
    }

    IKFAST_API bool ComputeIk2(const IkReal *eetrans, const IkReal *eerot, const IkReal *pfree, IkSolutionListBase<IkReal> &solutions, void *pOpenRAVEManip)
    {
        IKSolver solver;
        return solver.ComputeIk(eetrans, eerot, pfree, solutions);
    }

    IKFAST_API const char *GetKinematicsHash() { return "<robot:GenericRobot - bagger_test (19d5fc29775bf8eb5252a86cd30bcb26)>"; }

    IKFAST_API const char *GetIkFastVersion() { return "0x1000004a"; }

#ifdef IKFAST_NAMESPACE
} // end namespace
#endif

#ifndef IKFAST_NO_MAIN
#include <stdio.h>
#include <stdlib.h>
#ifdef IKFAST_NAMESPACE
using namespace IKFAST_NAMESPACE;
#endif
int main(int argc, char **argv)
{
    if (argc != 6 + GetNumFreeParameters() + 1)
    {
        printf("\nUsage: ./ik j0 j1 j2 t0 t1 t2 free0 ...\n\n"
               "Returns the ik solutions given the transformation of the end effector specified by\n"
               "a 3x1 translation (tX). j0-j1 can be used to calculate forward kinematics.\n"
               "There are %d free parameters that have to be specified. (%d)\n\n",
               GetNumFreeParameters(), argc);
        return 1;
    }

    IkReal j[3], fk[3];
    j[0] = atof(argv[1]);
    j[1] = atof(argv[2]);
    j[2] = atof(argv[3]);

    IkSolutionList<IkReal> solutions;
    std::vector<IkReal> vfree(GetNumFreeParameters());
    IkReal eerot[9] = {0.0}, eetrans[3];
    eetrans[0] = atof(argv[4]);
    eetrans[1] = atof(argv[5]);
    eetrans[2] = atof(argv[6]);

    for (std::size_t i = 0; i < vfree.size(); ++i)
        vfree[i] = atof(argv[7 + i]);

    ComputeFk(j, fk, NULL);
    printf("Solving FK for (j0, j1, j2)=(%.2f, %.2f, %.2f) gives (x, y, z)=(%.8f, %.8f, %.8f)\n",
           j[0], j[1], j[2], fk[0], fk[1], fk[2]);

    printf("Solving IK for (x, y, z): (%.2f, %.2f, %.2f) and free=%0.2f rad\n",
           eetrans[0], eetrans[1], eetrans[2], vfree[0]);

    bool bSuccess = ComputeIk(eetrans, eerot, vfree.size() > 0 ? &vfree[0] : NULL, solutions);

    if (!bSuccess)
    {
        printf("Failed to get ik solution\n");
        return -1;
    }

    printf("Found %d ik solutions:\n", (int)solutions.GetNumSolutions());
    std::vector<IkReal> solvalues(GetNumJoints());
    for (std::size_t i = 0; i < solutions.GetNumSolutions(); ++i)
    {
        const IkSolutionBase<IkReal> &sol = solutions.GetSolution(i);
        printf("sol%d (free=%d): ", (int)i, (int)sol.GetFree().size());
        std::vector<IkReal> vsolfree(sol.GetFree().size());
        sol.GetSolution(&solvalues[0], vsolfree.size() > 0 ? &vsolfree[0] : NULL);
        for (std::size_t j = 0; j < solvalues.size(); ++j)
            printf("%.15f, ", solvalues[j]);
        printf("\n");
    }
    return 0;
}

#endif
